searchNodes=[{"ref":"Waffle.Storage.Google.CloudStorage.html","title":"Waffle.Storage.Google.CloudStorage","type":"module","doc":"The main storage integration for Waffle, this acts primarily as a wrapper around Google.Api.Storage.V1. To use this module with Waffle, simply set your :storage config appropriately: config :waffle, storage: Waffle.Storage.Google.CloudStorage Ensure you have a valid bucket set, either through the configs or as an environment variable, otherwise all calls will fail. The credentials available through Goth must have the appropriate level of access to the bucket, otherwise some (or all) calls may fail."},{"ref":"Waffle.Storage.Google.CloudStorage.html#bucket/1","title":"Waffle.Storage.Google.CloudStorage.bucket/1","type":"function","doc":"Returns the bucket for file uploads."},{"ref":"Waffle.Storage.Google.CloudStorage.html#conn/1","title":"Waffle.Storage.Google.CloudStorage.conn/1","type":"function","doc":"Constructs a new connection object with scoped authentication. If no scope is provided, the devstorage.full_control scope is used as a default."},{"ref":"Waffle.Storage.Google.CloudStorage.html#delete/3","title":"Waffle.Storage.Google.CloudStorage.delete/3","type":"function","doc":"Delete a file from a Google Cloud Storage bucket."},{"ref":"Waffle.Storage.Google.CloudStorage.html#path_for/3","title":"Waffle.Storage.Google.CloudStorage.path_for/3","type":"function","doc":"Returns the full file path for the upload destination."},{"ref":"Waffle.Storage.Google.CloudStorage.html#put/3","title":"Waffle.Storage.Google.CloudStorage.put/3","type":"function","doc":"Put a Waffle file in a Google Cloud Storage bucket."},{"ref":"Waffle.Storage.Google.CloudStorage.html#storage_dir/3","title":"Waffle.Storage.Google.CloudStorage.storage_dir/3","type":"function","doc":"Returns the storage directory within a bucket to store the file under."},{"ref":"Waffle.Storage.Google.CloudStorage.html#url/4","title":"Waffle.Storage.Google.CloudStorage.url/4","type":"function","doc":"Retrieve the public URL for a file in a Google Cloud Storage bucket. Uses Waffle.Storage.Google.UrlV2 by default, which uses v2 signing if a signed URL is requested, but this can be overriden in the options list or in the application configs by setting :url_builder to any module that imlements the behavior of Waffle.Storage.Google.Url."},{"ref":"Waffle.Storage.Google.CloudStorage.html#t:object_or_error/0","title":"Waffle.Storage.Google.CloudStorage.object_or_error/0","type":"type","doc":""},{"ref":"Waffle.Storage.Google.Url.html","title":"Waffle.Storage.Google.Url","type":"behaviour","doc":"Defines an interface for generating Google Cloud Storage URLs."},{"ref":"Waffle.Storage.Google.Url.html#c:build/4","title":"Waffle.Storage.Google.Url.build/4","type":"callback","doc":"Constructs a URL based on data from Waffle."},{"ref":"Waffle.Storage.Google.UrlV2.html","title":"Waffle.Storage.Google.UrlV2","type":"module","doc":"This is an implementation of the v2 URL signing for Google Cloud Storage. See the Google documentation for more details. The bulk of the major logic is taken from Martide&#39;s arc_gcs work: https://github.com/martide/arc_gcs."},{"ref":"Waffle.Storage.Google.UrlV2.html#build/3","title":"Waffle.Storage.Google.UrlV2.build/3","type":"function","doc":"Same as build(definition, version, meta, [])."},{"ref":"Waffle.Storage.Google.UrlV2.html#endpoint/1","title":"Waffle.Storage.Google.UrlV2.endpoint/1","type":"function","doc":"Returns the remote asset host. The config key is assumed to be :asset_host."},{"ref":"Waffle.Storage.Google.UrlV2.html#expiry/1","title":"Waffle.Storage.Google.UrlV2.expiry/1","type":"function","doc":"Returns the amount of time, in seconds, before a signed URL becomes invalid. Assumes the key for the option is :expires_in."},{"ref":"Waffle.Storage.Google.UrlV2.html#signed?/1","title":"Waffle.Storage.Google.UrlV2.signed?/1","type":"function","doc":"Determines whether or not the URL should be signed. Assumes the key for the option is :signed."},{"ref":"Waffle.Storage.Google.Util.html","title":"Waffle.Storage.Google.Util","type":"module","doc":"A collection of utility functions."},{"ref":"Waffle.Storage.Google.Util.html#build_binary_body/2","title":"Waffle.Storage.Google.Util.build_binary_body/2","type":"function","doc":"Builds a Tesla.Multipart structure containing two parts: a binary payload and metadata about the binary payload. The metadata argument must be JSON encodable, i.e. it must succeed when passed to Poison.encode!/1."},{"ref":"Waffle.Storage.Google.Util.html#option/3","title":"Waffle.Storage.Google.Util.option/3","type":"function","doc":"Attempts to return a value from a given options list, using the application configs as a back-up. The application (used in Application.get_env/3) is assumed to be :waffle. This assumes that the application environment is set using waffle as the application name. If the value is not found in any of those location, an optional default value can be returned."},{"ref":"Waffle.Storage.Google.Util.html#prepend_slash/1","title":"Waffle.Storage.Google.Util.prepend_slash/1","type":"function","doc":"If the given string does not already start with a forward slash, this function will prepend one and return the result. Examples &gt; prepend_slash(&quot;some/path&quot;) &quot;/some/path&quot; &gt; prepend_slash(&quot;/im/good&quot;) &quot;/im/good&quot;"},{"ref":"Waffle.Storage.Google.Util.html#storage_objects_insert_binary/4","title":"Waffle.Storage.Google.Util.storage_objects_insert_binary/4","type":"function","doc":"For some reason, the Elixir library for Google Cloud Storage DOES NOT support binary data uploads. Their code always assumes that a path to a file is being passed to it and constructs the request as such. More infuriating is that Tesla, the HTTP library being used to make these requests, converts file paths to binary streams anyway, so adding the data to a temporary file would add additional steps. Specifically, we&#39;d be doing the following: Receive binary data (maybe from a stream). Write the binary data to a temporary file. Tesla opens the temporary file as a stream. The request is made. Delete the temporary file. Internally, Google relies solely on Tesla.Multipart.add_file/3 which creates a stream from the given filepath and then calls Tesla.Multipart.add_file_content/3. I have bypassed this step by creating a multipart struct manually, adding the binary data with add_file_content, and setting it to the request body. Fun fact: if you have no file param and your body param has a single entry of {:body, _}, the Google connection will use whatever the value is verbatim. We take advantage of that weird fact to bypass their custom build_body logic."},{"ref":"Waffle.Storage.Google.Util.html#var/1","title":"Waffle.Storage.Google.Util.var/1","type":"function","doc":"Accepts four forms of variables: The tuple {:system, key}, which uses System.get_env/1. The tuple {:app, key}, which uses Application.get_env/2. The tuple {:app, app, key}, which usees Application.get_env/2. Anything else which is returned as-is. In the second form ({:app, key}), the application is assumed to be :waffle although this can be overriden using the third form ({:app, app, key})."},{"ref":"Waffle.Types.html","title":"Waffle.Types","type":"module","doc":"This is hack until Waffle declares formal typespecs in its own project."},{"ref":"Waffle.Types.html#t:definition/0","title":"Waffle.Types.definition/0","type":"type","doc":""},{"ref":"Waffle.Types.html#t:file/0","title":"Waffle.Types.file/0","type":"type","doc":""},{"ref":"Waffle.Types.html#t:meta/0","title":"Waffle.Types.meta/0","type":"type","doc":""},{"ref":"Waffle.Types.html#t:version/0","title":"Waffle.Types.version/0","type":"type","doc":""}]